/**
 * Объект найденых камер, малофункционален, только для хранения начальной инфы
 * URL service @param in_sUAdress
 * IP and PORT @param in_sAdress
 * Сервис Onvif @param in_sNService
 * Имя устройства @param in_sHardware
 * Имя @param in_sName
 * Приставки к нэймспейсам @param in_oNS
 *
 * Логин и пароль присваиваются в дальнейшем при добавлении устрйства камеры
 *
 * @constructor
 */
OnvifFindedCam = function (in_sUAdress, in_sAdress, in_sNService, in_sHardware, in_sName, in_oNS)
{
    this.UAdress = in_sUAdress;
    this.Adress = in_sAdress;
    this.Service = in_sNService;
    this.Hardware = in_sHardware;
    this.Name = in_sName;

    this.Login = "";
    this.Password = "";

    this.NS =
        {
            S: in_oNS.S,
            D: in_oNS.D,
            A: in_oNS.A
        }
};
/**
 * Основной объект камеры, со всем функционалом
 * Объект найденой камеры которую необходимо создать @param in_oFindedCam
 * Объект для коммуникации по протоколу SOAP @param in_oSOAP
 * @constructor
 */
OnvifCam = function (in_oFindedCam, in_oSOAP)
{
    var UAdress = in_oFindedCam.UAdress;
    var Adress = in_oFindedCam.Adress;
    var Port = 80;
    if (in_oFindedCam.Adress.split(":")[1])
        Port = in_oFindedCam.Adress.split(":")[1];
    var Service = in_oFindedCam.Service;
    var MediaService;

    var l_sGoodName = UAdress.replace(/\./g,"");

    var PTZService;
    var PTZToken;

    var EventService = "onvif/Events";
    var l_oStreamRefreshTimeout;
    var l_oSnapShotRefreshTimeout;

    var l_bServicesError = false; 

    var SOAP = in_oSOAP;
    var HTTPDriver = IR.CreateDevice(IR.DEVICE_CUSTOM_HTTP_TCP, l_sGoodName, {Host: Adress.split(":")[0], Port: Port});

    HTTPDriver.SetParameters({Host: Adress.split(":")[0], Port: Port});
    HTTPDriver.Connect();

    var l_oSubDevice = IR.GetDevice(l_sGoodName);
    l_oSubDevice.AddTag("SetImage", [0x00, 0x00, 0x00, 0x00]);
    l_oSubDevice.AddTag("StateConnected", [0x00, 0x00, 0x00, 0x00]);
    l_oSubDevice.AddTag("StateAuth", [0x00, 0x00, 0x00, 0x00]);
    l_oSubDevice.AddTag("StateLoading", [0x00, 0x00, 0x00, 0x00]);
    l_oSubDevice.AddTag("PTZSupport", [0x00, 0x00, 0x00, 0x00]);
    l_oSubDevice.AddChannel("PTZ", [0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00]);




    l_oSubDevice.AddTag("ShowPopup", [0x00, 0x00, 0x00, 0x00]);
    var l_nShowPopupCounter = 0;

    var AuthData =
        {
            Login: in_oFindedCam.Login,
            Password: in_oFindedCam.Password,
            CamTimeOnAuth: 0,
            ModuleTimeOnAuth: 0
        };

    this.GetLogin = function () {return AuthData.Login;};
    this.GetPassword = function () {return AuthData.Password;};
    this.SetLogin = function (in_sLogin) {return AuthData.Login = in_sLogin;};
    this.SetPassword = function (in_sPassword) {return AuthData.Password = in_sPassword;};

    var NS =
        {
            S: in_oFindedCam.NS.S,
            D: in_oFindedCam.NS.D,
            A: in_oFindedCam.NS.A
        };

    function SyncTime()
    {
        //GCam.StateLoading(true);
        l_oSubDevice.SetFeedback("StateLoading", true);
        Send(SOAP.GetSystemDateAndTime(), SOAP.DATA.GetSystemDateAndTime.Action, syncTimeParse, Service);
        l_bServicesError = false;
        
    }

    var l_bToggle = false;
    IR.AddListener(IR.EVENT_CHANNEL_SET, HTTPDriver, fChannelSet = function (in_sTag, in_sValue) {
            switch(in_sValue){
                case "Zoom":
                    if(l_bToggle === true)
                    {
                        PTZZoom(0.1);
                        l_bToggle = false
                    }else
                    {
                        PTZZoom(-0.1);
                        l_bToggle = true;
                    }
                    break;
                case "Top":
                    PTZContinuousMove(0,0.5);
                    break;
                case "TopRight":
                    PTZContinuousMove(0.5,0.5);
                    break;
                case "TopLeft":
                    PTZContinuousMove(-0.5,0.5);
                    break;
                case "Left":
                    PTZContinuousMove(-0.5,0);
                    break;
                case "Right":
                    PTZContinuousMove(0.5,0);
                    break;
                case "Bot":
                    PTZContinuousMove(0,-0.5);
                    break;
                case "BotRight":
                    PTZContinuousMove(0.5,-0.5);
                    break;
                case "BotLeft":
                    PTZContinuousMove(-0.5,-0.5);
                    break;
                case "Stop":
                    PTZStop();
                    break;
        }
    });
    SyncTime();

    function GetCapabilities()
    {
        Send(SOAP.GetCapabilities(AuthData), SOAP.DATA.GetCapabilities.Action, capabilitiesResponse, Service);
    }

    function GetConfigurations()
    {
        Send(SOAP.GetConfigurations(AuthData), SOAP.DATA.GetConfigurations.Action, GetConfigurationsResponse, PTZService);
    }
    function GetConfigurationOptions()
    {
        Send(SOAP.GetConfigurationOptions(AuthData, PTZToken), SOAP.DATA.GetConfigurationOptions.Action, GetConfigurationOptionsResponse, PTZService);
    }
    function PTZContinuousMove(in_x, in_y)
    {
        Send(SOAP.PTZContinuousMove(AuthData, l_sProfile, in_x, in_y), SOAP.DATA.PTZContinuousMove.Action, PTZContinuousMoveResponse, PTZService);
    }
    function PTZZoom(in_zoom)
    {
        Send(SOAP.PTZZoom(AuthData, l_sProfile, in_zoom), SOAP.DATA.PTZContinuousMove.Action, PTZContinuousMoveResponse, PTZService);
    }
    function PTZAbsoluteMove(in_x, in_y)
    {
        Send(SOAP.PTZAbsoluteMove(AuthData, l_sProfile, in_x, in_y), SOAP.DATA.PTZAbsoluteMove.Action, PTZAbsoluteMoveResponse, PTZService);
    }
    function PTZStop()
    {
        Send(SOAP.PTZStop(AuthData, l_sProfile), SOAP.DATA.PTZStop.Action, PTZStopResponse, PTZService);
    }
    function PTZAbsoluteMoveResponse(in_sText)
    {
    }
    function PTZStopResponse(in_sText)
    {
    }
    function PTZContinuousMoveResponse(in_sText)
    {
    }

    function GetVideoSources()
    {
        Send(SOAP.GetVideoSources(AuthData), SOAP.DATA.GetVideoSources.Action, VideoSourcesResponse, Service);
    }

    function GetServices()
    {
        Send(SOAP.GetServices(AuthData), SOAP.DATA.GetServices.Action, servicesResponse, Service);
    }

    function PullPointSubscription()
    {
        Send(SOAP.GetPullPointSubscription(AuthData), SOAP.DATA.GetPullPointSubscription.Action, PullPointSubscriptionResponse, Service);
    }

    function GetScopes()
    {
        Send(SOAP.GetScopes(AuthData), SOAP.DATA.GetScopes.Action, scopesResponse, Service);
    }

    function GetStreamUri(in_sToken, in_sStream)
    {
        Send(SOAP.GetStreamUri(AuthData, in_sToken, in_sStream), SOAP.DATA.GetStreamUri.Action, streamResponse, MediaService);
    }

    function GetSnapshotUri(in_sToken, in_sStream)
    {
        Send(SOAP.GetSnapshotUri(AuthData, in_sToken, in_sStream), SOAP.DATA.GetSnapshotUri.Action, getsnapshoturiresponse, MediaService);
    }

    function GetProfiles()
    {
        Send(SOAP.GetProfiles(AuthData), SOAP.DATA.GetProfiles.Action, profilesResponse, MediaService);
    }

    function GetProfile(in_sProfile)
    {
        Send(SOAP.GetProfile(AuthData, in_sProfile), SOAP.DATA.GetProfile.Action, profileResponse, MediaService);
    }

    function wsdlGetProfile()
    {
        Send(SOAP.wsdlGetProfile(AuthData), SOAP.DATA.wsdlGetProfile.Action, wsdlprofileResponse, MediaService);
    }

    function GetNetInterfaces()
    {
        Send(SOAP.GetNetInterfaces(AuthData), SOAP.DATA.GetNetInterfaces.Action, authResponse, Service);
    }

    function GetNetworkProtocols()
    {
        Send(SOAP.GetNetworkProtocols(AuthData), SOAP.DATA.GetNetworkProtocols.Action, protocolsResponse, Service);
    }

    function VideoSourcesResponse(in_sText, in_nCode)
    {
        GetProfiles();
    }

    function streamResponse(in_sText, in_nCode)
    {
        try
        {
            var l_xmlResponse = new XML(in_sText.replace(/\r|\n/g, ' '));
            var l_sImage = l_xmlResponse[NS.S + ":Envelope"][NS.S + ":Body"]["trt:GetStreamUriResponse"]["trt:MediaUri"]["tt:Uri"].toString();
            var l_sTimout = l_xmlResponse[NS.S + ":Envelope"][NS.S + ":Body"]["trt:GetStreamUriResponse"]["trt:MediaUri"]["tt:Timeout"].toString();
        } catch (err)
        {
            l_oSubDevice.SetFeedback("SetImage", "http://127.0.0.1");
        }
        if (l_sImage !== void 0)
        {
            if(!l_bServicesError)
            GetConfigurations();
            setImage(l_sImage);
            var l_nTimeOfTimeOut = parseTimout(l_sTimout);
            IR.ClearInterval(l_oStreamRefreshTimeout);
            if(l_nTimeOfTimeOut > 1000){}
            l_oStreamRefreshTimeout = IR.SetInterval(l_nTimeOfTimeOut, function()
            {
                GetStreamUri(l_sProfile, l_sStream);
            })
        }
    }

    function setImage(in_sImage)
    {
            if (AuthData.Login == "" && AuthData.Password == ""){
               l_oSubDevice.SetFeedback("SetImage", in_sImage);
               l_oSubDevice.SetFeedback("StateLoading", false);
            }
            else{
               l_oSubDevice.SetFeedback("SetImage", in_sImage.split("//")[0] + "//" + AuthData.Login + ":" + AuthData.Password + "@" + in_sImage.split("//")[1]);
               l_oSubDevice.SetFeedback("StateLoading", false);
               l_oSubDevice.SetFeedback("StateAuth", true);
               l_oSubDevice.SetFeedback("StateConnected", true);
               }
    }
    function parseTimout(in_sTiomout)
    {
        var l_RXtime = (/[0-9]{1,2}/).exec(in_sTiomout);
        var l_RXmodifer = (/[A-Z]{1}$/).exec(in_sTiomout);
        var l_nTime = 0;

        if(l_RXmodifer == "S")
            l_nTime = l_RXtime * 1000;
        if(l_RXmodifer == "M")
            l_nTime = l_RXtime * 60000;
        if(l_RXmodifer == "H")
            l_nTime = l_RXtime * 3600000;
        return l_nTime;
    }

    function PullPointSubscriptionResponse(in_sText, in_nCode)
    {
        GetVideoSources();
    }

    function GetConfigurationOptionsResponse(in_sText)
    {
    }

    function GetConfigurationsResponse(in_sText)
    {
        try
        {
            var l_xmlResponse = new XML(in_sText.replace(/\r|\n/g, ' '));
            var l_sPTZToken = l_xmlResponse[NS.S + ":Envelope"][NS.S + ":Body"]["tptz:GetConfigurationsResponse"]["tptz:PTZConfiguration"]["@token"];
        } catch (err)
        {
        }
        if (l_sPTZToken !== void 0)
        {
            PTZToken = l_sPTZToken;
            GetConfigurationOptions();
        }
    }

    function servicesResponse(in_sText, in_nCode)
    {

        if (in_sText.indexOf("Fault") !== -1)
        {
            //l_bServicesError = true;
            //GetCapabilities();
            GetProfiles();
        }
        else
        {
            GetProfiles();
        }
    }

    function capabilitiesResponse(in_sText, in_nCode)
    {
        try
        {
            var l_xmlResponse = new XML(in_sText.replace(/\r|\n/g, ' '));
            var l_sMediaService = l_xmlResponse[NS.S + ":Envelope"][NS.S + ":Body"]["tds:GetCapabilitiesResponse"]["tds:Capabilities"]["tt:Media"]["tt:XAddr"].toString();
            var l_sPTZService = l_xmlResponse[NS.S + ":Envelope"][NS.S + ":Body"]["tds:GetCapabilitiesResponse"]["tds:Capabilities"]["tt:PTZ"]["tt:XAddr"].toString();
        } catch (err)
        {
        }
        if (l_sPTZService !== void 0)
        {
            PTZService = GetService(l_sPTZService);
            l_oSubDevice.SetFeedback("PTZSupport", true);
        } else
        {
            l_oSubDevice.SetFeedback("PTZSupport", false);
        }
        if (l_sMediaService !== void 0)
        {
            MediaService = GetService(l_sMediaService);
            if (l_bServicesError)
            {
                PullPointSubscription();
            }
            else
            {
                GetServices();
            }
        }
    }
    function scopesResponse(in_sText, in_nCode)
    {
    }

    function profileResponse(in_sText, in_nCode)
    {
        GetStreamUri(l_sProfile, l_sStream);
    }

    function wsdlprofileResponse(in_sText, in_nCode)
    {
        GetStreamUri(l_sProfile, l_sStream);
    }

    var l_sProfile = "";
    var l_sStream = "";

    function profilesResponse(in_sText, in_nCode)
    {
        try
        {
            var l_xmlResponse = new XML(in_sText.replace(/\r|\n/g, ' '));
            l_sProfile = l_xmlResponse[NS.S + ":Envelope"][NS.S + ":Body"]["trt:GetProfilesResponse"]["trt:Profiles"]["@token"];
            l_sStream = l_xmlResponse[NS.S + ":Envelope"][NS.S + ":Body"]["trt:GetProfilesResponse"]["trt:Profiles"]["tt:Name"].toString();
            l_oSubDevice.SetFeedback("StateAuth", true);
        } catch (err)
        {
            l_oSubDevice.SetFeedback("SetImage", "http://127.0.0.1");
            l_oSubDevice.SetFeedback("StateAuth", false);
        }
        if (l_sProfile !== void 0)
        {
            if (l_bServicesError === true){
                GetSnapshotUri(l_sProfile, l_sStream);
                //GetProfile(l_sProfile);
            }
            else{
                GetProfile(l_sProfile);
            }
        }
    }
    function getsnapshoturiresponse(in_sText, in_nCode)
    {
        try
        {
            var l_xmlResponse = new XML(in_sText.replace(/\r|\n/g, ' '));
            var l_sImage = l_xmlResponse[NS.S + ":Envelope"][NS.S + ":Body"]["trt:GetSnapshotUriResponse"]["trt:MediaUri"]["tt:Uri"].toString();
            var l_sTimout = l_xmlResponse[NS.S + ":Envelope"][NS.S + ":Body"]["trt:GetSnapshotUriResponse"]["trt:MediaUri"]["tt:Timeout"].toString();
        } catch (err)
        {
            l_oSubDevice.SetFeedback("SetImage", "http://127.0.0.1");
        }
        if (l_sImage !== void 0)
        {
            setImage(l_sImage);

            var l_nTimeOfTimeOut = parseTimout(l_sTimout);
            IR.ClearInterval(l_oSnapShotRefreshTimeout);

            if(l_nTimeOfTimeOut > 1000)
                l_oSnapShotRefreshTimeout = IR.SetInterval(l_nTimeOfTimeOut, function()
                {
                    GetStreamUri(l_sProfile, l_sStream);
                })
        }
    }

    function protocolsResponse(in_sText, in_nCode)
    {
    }

    function authResponse(in_sText, in_nCode)
    {
    }

    function syncTimeParse(in_sText, in_nCode)
    {
        l_oSubDevice.SetFeedback("StateConnected", true);
            var l_xmlResponse = new XML(in_sText.replace(/\r|\n/g, ' '));
            var l_xmlSystemDT = l_xmlResponse[NS.S + ":Envelope"][NS.S + ":Body"]["tds:GetSystemDateAndTimeResponse"];

        if (l_xmlSystemDT !== void 0)
        {
            var l_xmlDate = void 0;
            var l_xmlTime = l_xmlSystemDT["tds:SystemDateAndTime"]["tt:UTCDateTime"]["tt:Time"];
            if (l_xmlTime === void 0)
            {
                l_xmlTime = l_xmlSystemDT["tds:SystemDateAndTime"]["tt:LocalDateTime"]["tt:Time"];
                l_xmlDate = l_xmlSystemDT["tds:SystemDateAndTime"]["tt:LocalDateTime"]["tt:Date"];
            } else
            {
                l_xmlDate = l_xmlSystemDT["tds:SystemDateAndTime"]["tt:UTCDateTime"]["tt:Date"];
            }

            var l_sHour = l_xmlTime["tt:Hour"].toString();
            var l_sMinute = l_xmlTime["tt:Minute"].toString();
            var l_sSecond = l_xmlTime["tt:Second"].toString();

            var l_sYear = l_xmlDate["tt:Year"].toString();
            var l_sMonth = l_xmlDate["tt:Month"].toString();
            var l_sDay = l_xmlDate["tt:Day"].toString();
            setDiffTime(toSpecialDate(l_sMonth, l_sDay, l_sYear, l_sHour, l_sMinute, l_sSecond));
        } else
        {
        }
    }
    //function syncTimeParse(in_sText, in_nCode){}
    function setDiffTime(in_sCamUtcTime)
    {
        AuthData.ModuleTimeOnAuth = new Date().getTime();
        AuthData.CamTimeOnAuth = new Date(in_sCamUtcTime).getTime();
        GetCapabilities();
    }

    function Send(in_sData, in_sAction, in_fCallback, in_Service)
    {
        HTTPDriver.SendEx({
            Type: "POST",
            Url: in_Service,
            Data: [in_sData],
            KeepAliveOut: 0,
            KeepAliveMax: 0,
            UserAgent: "1",
            Headers: {
                "Content-Type": 'application/soap+xml; charset=utf-8; action="' + in_sAction + '"',
                "Accept-Encoding": 'gzip, deflate'
            },
            cbReceiveText: in_fCallback
        });
    }

    function GetService(in_sAdress)
    {
        var l_aTempArray = in_sAdress.split("//")[1].split("/");
        l_aTempArray.shift();
        return "/" + l_aTempArray.join("/");
    }

    function toSpecialDate(in_sMonth, in_sDate, in_sYear, in_sHour, in_sMinute, in_sSecond)
    {
        var a = ["Jan", "Feb", "Mar", "Apr", "May", "June", "July", "Aug", "Sept", "Oct", "Nov", "Dec"];

        if (in_sMonth.slice(0, 1) == 0)
            in_sMonth = in_sMonth.replace("0", "");

        if (in_sDate.slice(0, 1) == 0)
            in_sDate = in_sDate.replace("0", "");

        if (in_sHour.length == 1)
            in_sHour = "0" + in_sHour;
        if (in_sMinute.length == 1)
            in_sMinute = "0" + in_sMinute;
        if (in_sSecond.length == 1)
            in_sSecond = "0" + in_sSecond;

        return a[parseInt(in_sMonth)] + " " + in_sDate + " " + in_sYear + " " + in_sHour + ":" + in_sMinute + ":" + in_sSecond + " UTC";
    }

};
