/**
 * Объект сканнера
 * На входе UDP девайс @param in_oDevice
 * Кэллбэк для выдачи найденых камер @param in_fCallback
 * Объект хранения всех найденых камер @param in_oCams
 * @constructor
 */
OnvifScanner = function(in_oDevice, in_fCallback, in_oCams)
{
	//Получаем девайс для Send
	var Device = in_oDevice;
	//Получаем кэлбэк функцию, для возварата ответивших(найденых) устройств
	var Callback = in_fCallback;
	//Объект очередной найденой 
	var l_oFindedCam = {};
	var l_oSearchInterval = {};
    var UUID = new UUIDGenerator();
	
	//Запуск сканера: создание слушателя, посыл первых мультикаст пакетов, 
	//создания интервала с переодическим посылом мультикаст пакетов

	this.Start = function ()
	{
		IR.AddListener(IR.EVENT_RECEIVE_TEXT, Device, fReceiveText);
		Device.Send([SEARCHDATA1 + UUID.generate() + SEARCHDATA2]);
		IR.ClearInterval(l_oSearchInterval);
		l_oSearchInterval = IR.SetInterval(1000, function()
		{
			Device.Send([SEARCHDATA1 + UUID.generate() + SEARCHDATA2]);
		});
	};

	
	//Удалить интервал поиска и слушатель
	this.Stop = function ()
	{
		IR.ClearInterval(l_oSearchInterval);
		IR.RemoveListener(IR.EVENT_RECEIVE_TEXT, Device, fReceiveText);
	};
	//Основная функция для обработки принятого текста от драйвера, после посыла мультикаст пакетов
	function fReceiveText(in_sText) 
	{
		var l_xmlResponse = new XML(in_sText.replace(/\r|\n/g, ' '));

		var l_NS = {};
		var l_sNAdress, l_sNService, l_sNHardware, l_sNName, l_sScopes, l_sUAdress;

		//Получаем нэймспэйсы для прямого доступа в XML объекте
		GetNameSpaces(in_sText, l_NS);

      if(!l_xmlResponse[l_NS.S + ":Envelope"]){
         return
      }
      if(!l_xmlResponse[l_NS.S + ":Envelope"][l_NS.S + ":Body"]){
         return
      }
      if(!l_xmlResponse[l_NS.S + ":Envelope"][l_NS.S + ":Body"][l_NS.D + ":ProbeMatches"]){
         return
      }
      if(!l_xmlResponse[l_NS.S + ":Envelope"][l_NS.S + ":Body"][l_NS.D + ":ProbeMatches"][l_NS.D + ":ProbeMatch"]){
         return
      }
      if(!l_xmlResponse[l_NS.S + ":Envelope"][l_NS.S + ":Body"][l_NS.D + ":ProbeMatches"][l_NS.D + ":ProbeMatch"][l_NS.D + ":XAddrs"].toString().split(" ")[0]){
         return
      }

		if(typeof l_xmlResponse[l_NS.S + ":Envelope"][l_NS.S + ":Body"][l_NS.D + ":ProbeMatches"][l_NS.D + ":ProbeMatch"] ==  "undefined")
			return;
		l_sUAdress = l_xmlResponse[l_NS.S + ":Envelope"][l_NS.S + ":Body"][l_NS.D + ":ProbeMatches"][l_NS.D + ":ProbeMatch"][l_NS.D + ":XAddrs"].toString().split(" ")[0];
       
		//Если такого UAdress еще не было
		if(l_oFindedCam[l_sUAdress] === void 0)
		{
			l_oFindedCam[l_sUAdress] = 1;
			l_sScopes = l_xmlResponse[l_NS.S + ":Envelope"][l_NS.S + ":Body"][l_NS.D + ":ProbeMatches"][l_NS.D + ":ProbeMatch"][l_NS.D + ":Scopes"].toString();			

			l_sNService = GetService(l_sUAdress);
			l_sNAdress = GetAdress(l_sUAdress);
			l_sNName = GetScope("name", l_sScopes);
			l_sNHardware = GetScope("hardware", l_sScopes);
			
			//Сохраняем кмеры для доступности их в гуи
			in_oCams[l_sUAdress] = new OnvifFindedCam(l_sUAdress, l_sNAdress, l_sNService, l_sNHardware, l_sNName, l_NS);
			//Передаем объект камеры в кэлбэк, там он добавится в лист найденых камер
         Callback(in_oCams[l_sUAdress]); 
		}
	}
    /**
	 * Отделяем адрес сервиса от uri для SendEx (/onvif/service)
     * @param in_sAdress
     * @returns {string}
     */
	function GetService(in_sAdress)
	{	
		var l_aTempArray = in_sAdress.split("//")[1].split("/");
		l_aTempArray.shift();
		return "/" + l_aTempArray.join("/");
	}
	//Отделяем адрес сервиса от uri для настройки драйвера (192.168.0.145)
	function GetAdress(in_sAdress)
	{
		return in_sAdress.split("//")[1].split("/")[0];
	}
	//Отделяем выделяем нужное нам значение из Scope ссылки
	function GetScope(in_sScope, in_sScopes)
	{			
		return in_sScopes.split(in_sScope + "/")[1].split(" ")[0];
	}
	//Получаем нэймспэйсы для прямого доступа в XML объекте, так уж вышло, такой стандарт
	function GetNameSpaces(in_sText, in_NS)
	{
		in_NS.S = GetNameSpace(in_sText, ":Envelope");
		in_NS.D = GetNameSpace(in_sText, ":ProbeMatches");
		in_NS.A = GetNameSpace(in_sText, ":MessageID");
		
		//Получаем конкретный нэймспэйс, по однозначному имени пути
		function GetNameSpace(in_sText, in_sNameSpace)
		{
			var l_sAnyNameSpace = in_sText.slice(0, in_sText.indexOf(in_sNameSpace)).split("<");
			l_sAnyNameSpace = l_sAnyNameSpace[l_sAnyNameSpace.length - 1];
			return l_sAnyNameSpace;
		}
	}

var switche = 1;
switch(switche){
	case 1:
			var SEARCHDATA1 = '<s:Envelope xmlns:s="http://www.w3.org/2003/05/soap-envelope" xmlns:a="http://schemas.xmlsoap.org/ws/2004/08/addressing">'; //Namespace declaration is never used
			SEARCHDATA1 += '<s:Header>';
				SEARCHDATA1 += '<a:Action s:mustUnderstand="1">http://schemas.xmlsoap.org/ws/2005/04/discovery/Probe</a:Action>';
				SEARCHDATA1 += '<a:MessageID>uuid:';
	
		var SEARCHDATA2 = '</a:MessageID>';
				SEARCHDATA2 += '<a:ReplyTo>';
					SEARCHDATA2 += '<a:Address>http://schemas.xmlsoap.org/ws/2004/08/addressing/role/anonymous</a:Address>';
				SEARCHDATA2 += '</a:ReplyTo>';
				SEARCHDATA2 += '<a:To s:mustUnderstand="1">urn:schemas-xmlsoap-org:ws:2005:04:discovery</a:To>';
			SEARCHDATA2 += '</s:Header>';
			SEARCHDATA2 += '<s:Body>';
				SEARCHDATA2 += '<Probe xmlns="http://schemas.xmlsoap.org/ws/2005/04/discovery">';
					SEARCHDATA2 += '<d:Types xmlns:d="http://schemas.xmlsoap.org/ws/2005/04/discovery" xmlns:dp0="http://www.onvif.org/ver10/network/wsdl">dp0:NetworkVideoTransmitter</d:Types>';
				SEARCHDATA2 += '</Probe>';
			SEARCHDATA2 += '</s:Body>';
		SEARCHDATA2 += '</s:Envelope>';
		break;
	case 2:
		var SEARCHDATA1 = '<?xml version="1.0" encoding="utf-8"?><soap:Envelope xmlns:soap="http://www.w3.org/2003/05/soap-envelope" xmlns:wsa="http://schemas.xmlsoap.org/ws/2004/08/addressing" xmlns:wsd="http://schemas.xmlsoap.org/ws/2005/04/discovery">  <soap:Header>    <wsa:To>urn:schemas-xmlsoap-org:ws:2005:04:discovery</wsa:To>    <wsa:Action>http://schemas.xmlsoap.org/ws/2005/04/discovery/Resolve</wsa:Action>    <wsa:MessageID>urn:uuid:29206488-217f-4a1d-83c7-da156409aec8</wsa:MessageID>  </soap:Header>  <soap:Body>    <wsd:Resolve>      <wsa:EndpointReference>        <wsa:Address>urn:uuid:1c852a4d-b800-1f08-abcd-6cc21717ea2a</wsa:Address>      </wsa:EndpointReference>    </wsd:Resolve>  </soap:Body></soap:Envelope>';
		break;
	case 3:
		var SEARCHDATA1 = '<?xml version="1.0" encoding="utf-8"?><s:Envelope xmlns:s="http://www.w3.org/2003/05/soap-envelope" xmlns:a="http://schemas.xmlsoap.org/ws/2004/08/addressing">  <s:Header>    <a:Action s:mustUnderstand="1">http://schemas.xmlsoap.org/ws/2005/04/discovery/Probe</a:Action>    <a:MessageID>uuid:8d1b1570-803f-43a8-9674-fd10983307ae</a:MessageID>    <a:ReplyTo>      <a:Address>http://schemas.xmlsoap.org/ws/2004/08/addressing/role/anonymous</a:Address>    </a:ReplyTo>    <a:To s:mustUnderstand="1">urn:schemas-xmlsoap-org:ws:2005:04:discovery</a:To>  </s:Header>  <s:Body>    <Probe xmlns="http://schemas.xmlsoap.org/ws/2005/04/discovery">      <d:Types xmlns:d="http://schemas.xmlsoap.org/ws/2005/04/discovery" xmlns:dn="http://www.onvif.org/ver10/network/wsdl" xmlns:tds="http://www.onvif.org/ver10/device/wsdl">dn:NetworkVideoTransmitter tds:Devicer</d:Types>    </Probe>  </s:Body></s:Envelope>';
		break;
	case 4:
		var SEARCHDATA1 =  '<?xml version="1.0" encoding="utf-8"?><s:Envelope xmlns:s="http://www.w3.org/2003/05/soap-envelope" xmlns:a="http://schemas.xmlsoap.org/ws/2004/08/addressing">  <s:Header>    <a:Action s:mustUnderstand="1">http://schemas.xmlsoap.org/ws/2005/04/discovery/Probe</a:Action>    <a:MessageID>uuid:a703f032-7a47-4800-84f4-b85addd26d2a</a:MessageID>    <a:ReplyTo>      <a:Address>http://schemas.xmlsoap.org/ws/2004/08/addressing/role/anonymous</a:Address>    </a:ReplyTo>    <a:To s:mustUnderstand="1">urn:schemas-xmlsoap-org:ws:2005:04:discovery</a:To>  </s:Header>  <s:Body>    <Probe xmlns="http://schemas.xmlsoap.org/ws/2005/04/discovery">      <d:Types xmlns:d="http://schemas.xmlsoap.org/ws/2005/04/discovery" xmlns:dp0="http://www.onvif.org/ver10/network/wsdl">dp0:NetworkVideoTransmitter</d:Types>    </Probe>  </s:Body></s:Envelope>';
		break;
}


};
/**
 * Fast UUID generator, RFC4122 version 4 compliant.
 * @author Jeff Ward (jcward.com).
 * @license MIT license
 * @link http://stackoverflow.com/questions/105034/how-to-create-a-guid-uuid-in-javascript/21963136#21963136
 * Объект генератора uuid
 * @returns {string} //xxxxxxxx-xxxx-4xxx-yxxx-xxxxxxxxxxxx
 * @constructor
 */
var UUIDGenerator = function() {
    var self = {};
    var lut = []; for (var i=0; i<256; i++) { lut[i] = (i<16?'0':'')+(i).toString(16); }
    self.generate = function() {
        var d0 = Math.random()*0xffffffff|0;
        var d1 = Math.random()*0xffffffff|0;
        var d2 = Math.random()*0xffffffff|0;
        var d3 = Math.random()*0xffffffff|0;
        return lut[d0&0xff]+lut[d0>>8&0xff]+lut[d0>>16&0xff]+lut[d0>>24&0xff]+'-'+
            lut[d1&0xff]+lut[d1>>8&0xff]+'-'+lut[d1>>16&0x0f|0x40]+lut[d1>>24&0xff]+'-'+
            lut[d2&0x3f|0x80]+lut[d2>>8&0xff]+'-'+lut[d2>>16&0xff]+lut[d2>>24&0xff]+
            lut[d3&0xff]+lut[d3>>8&0xff]+lut[d3>>16&0xff]+lut[d3>>24&0xff];
    };
    return self;
};